#from Thing import Thing

class BinaryMsg():
    id = 0xB1
    length = 3

    def __init__(self, data, thing = None):
        if isinstance(data, bytes):
            self.thing_id = data[2]
            self.data = data[3:]
        else:
            self.thing_id = thing.id
            self.thing = thing

    def Serialize(self, buffer_ref):
        if  self.thing_id is None:
            return 0
        
        buffer: bytearray = buffer_ref[0]
        ix = self.length
        self.thing.GenerateBinary(buffer, {ix})
        if ix <= self.length:
            return 0
        
        buffer[0] = self.id
        buffer[1] = 0 # network_id
        buffer[2] = self.thing_id
        return ix
